"""
    Handle input processing
"""

import pygame
from config import config

class Input:
    left = None
    right = None
    up = None
    down = None
    jump = None
    quit = None

    def proc_down(self, event):
        """Process keydown events"""

        if event.key == config.left:
            self.left = True
        elif event.key == config.right:
            self.right = True
        elif event.key == config.up:
            self.up = True
        elif event.key == config.down:
            self.down = True
        elif event.key == config.jump:
            self.jump = True
        elif event.key == config.quit:
            self.post_quit()

    def proc_up(self, event):
        """Process keyup events"""

        if event.key == config.left:
            self.left = None
        elif event.key == config.right:
            self.right = None
        elif event.key == config.up:
            self.up = None
        elif event.key == config.down:
            self.down = None
        elif event.key == config.jump:
            self.jump = None

    def get_left(self):
        return self.left
    
    def get_right(self):
        return self.right
    
    def get_up(self):
        return self.up
    
    def get_down(self):
        return self.down
    
    def get_jump(self):
        return self.jump

    def get_quit(self):
        return self.quit

    def toggle_left(self):
        self.left = not self.left

    def toggle_right(self):
        self.right = not self.right

    def toggle_up(self):
        self.up = not self.up

    def toggle_down(self):
        self.down = not self.down

    def toggle_jump(self):
        self.jump = not self.jump

    def post_quit(self):
        event = pygame.event.Event(pygame.QUIT)
        pygame.event.post(event)

input = Input()
