"""
    Simple tool for dealing with lines
"""

class Line:
    x1 = None
    y1 = None

    x2 = None
    y2 = None

    m = None
    b = None

    def __init__(self, (x1,y1), (x2,y2)):
        """Initialize the line"""

        self.x1 = float(x1)
        self.x2 = float(x2)

        self.y1 = float(y1)
        self.y2 = float(y2)

        self.m = float(0.0)
        self.b = float(0.0)
        
        # Find the slope of the line
        if (self.x1 == self.x2):
            # Vertical
            self.m = None
            self.b = None
        else:
            if (self.y1 == self.y2):
                # Horizontal
                self.m = float(0,0)
                self.b = self.y1
            else:
                self.m = (self.y1 - self.y2) / (self.x1 - self.x2)
                self.b = self.y1 - (self.x1 * self.m) 

def intersect(line1, line2):
    """Returns the x/y cordinate where these lines intersect"""
    
    x = None
    y = None
    
    # Find out if the lines are parallel
    if (line1.m == line2.m):
        return (None, None)
  
    # If line1 is vertical, any x from line1 will do
    if line1.b == None:
        x = line1.x1
    elif line2.b == None:
        x = line2.x1
    else:
        # mx + b = mx + b
        # invert line1's b
        # invert line2's m
        #
        # add line1's b to line2's b == tmp_b
        # add line2's m to line1's m == tmp_m
        #
        # divide tmp_b by tmp_m for x
        tmp_b = line1.b * -1
        tmp_m = line2.m * -1

        tmp_b = line2.b + tmp_b
        tmp_m = line1.m + tmp_m

        x = tmp_b / tmp_m

    # Find y now
    y = (line1.m * x) + line1.b

    return (x, y)

# Sample lines, intersect at (2,2)
#l1 = Line((1,1), (3,3))
#l2 = Line((1,3), (3,1))
